local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local c = BittensSpellFlashLibrary

local GetTime = GetTime
local IsMounted = IsMounted
local select = select

a.Rotations = {}
c.RegisterForEvents(a)
a.SetSpamFunction(function()
	c.Flash(a)
end)

local function flashSummon(...)
	if IsMounted() then
		return
	end
	
	if c.HasTalent("Grimoire of Sacrifice") then
		if not c.SelfBuffNeeded("Grimoire of Sacrifice") then
			return
		end
		
		if x.PetAlive then
			s.Flash(c.GetID("Grimoire of Sacrifice"), "yellow")
			return
		end
	end
	
	local current = a.GetCurrentPet()
	for i = 1, select("#", ...) do
		if select(i, ...) == current then
			return
		end
	end
	
	s.Flash(c.GetID("Summon Demon"), "yellow")
	for i = 1, select("#", ...) do
		s.Flash(c.GetID("Summon " .. select(i, ...)), "yellow")
	end
end

a.Rotations.Afliction = {
	Spec = 1,
	OffSwitch = "affliction_off",
	
	FlashInCombat = function()
		c.FlashAll(
			"Curse of the Elements",
			"Dark Soul: Misery",
			"Soulburn under Dark Soul: Misery",
			"Soul Swap under Soulburn",
			"Grimoire: Felhunter",
			"Spell Lock",
			"Optical Blast")
		if s.HealthPercent() <= 20 then
			c.PriorityFlash(
				"Haunt",
				"Soulburn during Execute",
				"Soul Swap during Execute",
				"Life Tap",
				"Drain Soul")
		else
			c.PriorityFlash(
				"Haunt",
				"Agony",
				"Corruption",
				"Unstable Affliction",
				"Life Tap",
				"Malefic Grasp")
		end
	end,
	
	FlashAlways = function()
		c.FlashAll("Dark Intent")
		flashSummon("Felhunter", "Observer")
	end,
	
	AuraApplied = function(spellID)
		
		-- Do this here instead of c.ManageDotRefresh so that it updates when
		-- cast via Soul Swap
		if spellID == c.GetID("Corruption") then
			c.GetSpell("Corruption").EarlyRefresh = c.GetHastedTime(2)
		elseif spellID == c.GetID("Unstable Affliction") then
			c.GetSpell("Unstable Affliction").EarlyRefresh = c.GetHastedTime(2)
		end
	end,
}

--a.ImmolateRefresh = 0
--a.Rotations.Demonology = {
--	Spec = 2,
--	OffSwitch = "demonology_off",
--	
--	FlashInCombat = function()
--		a.FlashAll(
--			"Felstorm",
--			"Curse of the Elements",
--			"Metamorphosis",
--			"Summon Doomguard",
--			"Demon Soul",
--			"Axe Toss",
--			"Spell Lock")
--		a.Flash(
--			"Soul Fire with T13",
--			"Immolate",
--			"Bane of Doom",
--			"Bane of Agony",
--			"Summon Felhunter in Combat",
--			"Corruption",
--			"Shadowflame",
--			"Hand of Gul'dan",
--			"Immolation Aura",
--			"Incinerate under Molten Core",
--			"Refresh Bane of Doom",
--			"Life Tap",
--			"Soul Fire and Soulburn",
--			"Soul Fire under Decimation",
--			"Incinerate")
--	end,
--	
--	FlashOutOfCombat = function()
--		a.FlashAll("Create Soulstone")
--		a.Flash("Summon Felguard", "Soul Link")
--		a.Flash("Life Tap out of Combat", "Soul Harvest")
--	end,
--	
--	FlashAlways = function()
--		a.FlashAll("Dark Intent", "Fel Armor")
--	end,
--	
--	CastSucceeded = trackDarkIntent,
--	
--	SpellDamage = function(
--		spellID, target, amount, critical, spellSchool, damageSchool, periodic)
--		
--		if spellID == c.GetID("Hand of Gul'dan")
--			and s.MyDebuff(c.GetID("Immolate"))
--			and c.HasTalent("Cremation") then
--			
--			a.ImmolateRefresh = GetTime()
--			c.Debug("Event", "Immolate Refresh")
--		end
--	end,
--}
--
--a.Rotations.Destruction = {
--	Spec = 3,
--	OffSwitch = "destro_off",
--	
--	FlashInCombat = function()
--		a.FlashAll(
--			"Curse of the Elements",
--			"Demon Soul",
--			"Summon Doomguard",
--			"Spell Lock")
--		a.Flash(
--			"Soul Fire for Improved Soul Fire",
--			"Soul Fire with T13",
--			"Immolate",
--			"Conflagrate",
--			"Bane of Doom",
--			"Bane of Agony",
--			"Corruption",
--			"Shadowburn",
--			"Shadowflame",
--			"Soul Fire under Empowered Imp",
--			"Chaos Bolt",
--			"Refresh Bane of Doom",
--			"Life Tap",
--			"Incinerate")
--	end,
--	
--	FlashOutOfCombat = function()
--		a.Flash("Create Soulstone")
--		a.Flash("Life Tap out of Combat", "Soul Harvest")
--	end,
--	
--	FlashAlways = function()
--		a.FlashAll("Dark Intent", "Fel Armor")
--		a.Flash("Summon Imp", "Soul Link")
--	end,
--	
--	CastSucceeded = trackDarkIntent,
--}
